--------------------------------------------------------------------------------------------------
-- Titan Panel [MatTracker] Ver: 0.9-3.1
-- Author: Kierly of Burning Legion
-- Last Edit:  Apr 21, 2009
--------------------------------------------------------------------------------------------------

TITAN_MATTRACKER_ID = "MatTracker";
TITAN_MATTRACKER_VERSION = GetAddOnMetadata("TitanMatTracker", "Version")
TITAN_MATTRACKER_TEXT = "Titan MatTracker";

TitanMatTracker_active = nil;

function TitanPanelMatTrackerButton_OnLoad(self)
	self.registry = {
		id = TITAN_MATTRACKER_ID,
		version = TITAN_MATTRACKER_VERSION,
		menuText = TITAN_MATTRACKER_TEXT,
		category = "Profession",
		--buttonTextFunction = "TitanPanelMatTrackerButton_GetButtonText",
		tooltipTitle = TITAN_MATTRACKER_TEXT,
		tooltipTextFunction = "TitanPanelMatTrackerButton_GetTooltipText",
		savedVariables = {
			ShowLabelText = 1,
			ShowColoredText = TITAN_NIL,
			ShowIcon = 1,
      showMatIcons = 1,
      --trackMat = { false, false, false, false, false, false, false, false, false, false , false, false };
			shortdisplay = TITAN_NIL,
			displayMats = {},
      displayCats = {},
      tooltip_loc_bank   = 1,
      tooltip_loc_inv    = 1,
      tooltip_loc_mail   = 1,
      tooltip_loc_reroll = 1,
      tooltip_loc_gbank  = 1,
      tooltip_showZero   = 1,
		}
	};

	self:RegisterEvent("PLAYER_ENTERING_WORLD")
  self:RegisterEvent("BAG_UPDATE")
end

function TitanPanelMatTrackerButton_OnEvent(self, event, ...)
	if (event == "PLAYER_ENTERING_WORLD") then
		TitanMatTracker_active = 1;
	end
  if (event == "BAG_UPDATE") then
    TitanPanelMatTracker_UpdateButton()
    TitanPanelButton_UpdateTooltip(self)
  end
end

function TitanPanelMatTracker_UpdateButton()
  local tracking = false
  local totalWidth = 0
  local offset = 0
  local name = "TitanPanelMatTrackerButtonMaterial"
  local title = ""
  local text = ""
  local e = nil
  local disp = TitanGetVar(TITAN_MATTRACKER_ID, "displayMats");

  if((not disp or (table.getn(disp) == 0) or not MTracker)
		and not TitanGetVar(TITAN_MATTRACKER_ID, "ShowLabelText")
		and not TitanGetVar(TITAN_MATTRACKER_ID, "ShowIcon")) then
		TitanSetVar(TITAN_MATTRACKER_ID, "ShowLabelText", 1);
		--TitanPanelButton_UpdateButton(TITAN_MATTRACKER_ID);
	end;
  
  _G[name.."1"]:Hide()
  _G[name.."2"]:Hide()
  _G[name.."3"]:Hide()
  _G[name.."4"]:Hide()
  _G[name.."5"]:Hide()
  _G[name.."6"]:Hide()
  _G[name.."7"]:Hide()
  _G[name.."8"]:Hide()
  _G[name.."9"]:Hide()
  _G[name.."10"]:Hide()
  _G[name.."11"]:Hide()
  _G[name.."12"]:Hide()
  
  for index, mat in pairs(disp) do
    local button = _G[name..index]
    local nextButton = _G[name..(index + 1)]
    local nextAnchor = "LEFT"
    local nextOffset = 0
    
    e = TITAN_MATTRACKER_MATS.byId[mat];
    
    --  show/hide Material Trackers
    if (index <= 12) then
      local icon = _G[name..index.."Icon"]
      button:Show()
      
      if (TitanGetVar(TITAN_MATTRACKER_ID, "showMatIcons")) then
        icon:SetTexture(GetItemIcon(mat))
        icon:Show()
        title = ""
      else 
        if (TitanGetVar(TITAN_MATTRACKER_ID, "shortdisplay")) then
          title = TitanPanelMatTrackerButton_FormatColoredText(e.color, e.short)..": "
          icon:SetTexture(nil);
          icon:Hide()
        else
          title = e.item..": "
          icon:SetTexture(nil);
          icon:Hide()
        end
      end
      
      text = format("%d",TitanPanelMatTrackerButton_MatsTotalFromCode(mat))
      if (TitanGetVar(TITAN_MATTRACKER_ID, "ShowColoredText")) then
        text = TitanPanelMatTrackerButton_FormatColoredText(e.color, text)
      end
      
      button:SetText(title..text)
      
      if nextButton then
        nextAnchor = "RIGHT"
        nextOffset = 6
      end
      
      if (TitanGetVar(TITAN_MATTRACKER_ID, "showMatIcons")) then
        button:SetWidth(icon:GetWidth() + button:GetTextWidth())
      else
        button:SetWidth(button:GetTextWidth())
      end
      totalWidth = totalWidth + button:GetWidth();
      
      offset = offset+1
      tracking = true
    end
    
    if nextButton then
      nextButton:SetPoint("LEFT", button, nextAnchor, nextOffset, 0)
    end
  end
  
  local none = _G[name.."None"]
  if tracking then
    none:Hide()
  else
    none:Show()
    totalWidth = none:GetWidth() + 8
  end
  
  TitanPanelMatTrackerButton:SetWidth(totalWidth + ((offset - 1) * 8))
end

function TitanPanelMatTrackerButton_GetButtonText(id)
	local title = TITAN_MATTRACKER_TEXT;
	local text = "";
	local disp = TitanGetVar(TITAN_MATTRACKER_ID, "displayMats");
	-- preventing getting inaccessible due to no display at all
	if(	(not disp or (table.getn(disp) == 0 ) or not MTracker)
		and not TitanGetVar(TITAN_MATTRACKER_ID, "ShowLabelText")
		and not TitanGetVar(TITAN_MATTRACKER_ID, "ShowIcon")) then
		TitanSetVar(TITAN_MATTRACKER_ID, "ShowLabelText", 1);
		TitanPanelButton_UpdateButton(TITAN_MATTRACKER_ID);
	end;

	if(not MTracker) then
		return TITAN_MATTRACKER_TEXT,"";
	end
	
	local i,d,e;
	local liste = {};
	for i,d in pairs(disp) do
		e = TITAN_MATTRACKER_MATS.byId[d];
		if(TitanGetVar(TITAN_MATTRACKER_ID, "shortdisplay")) then
			title = TitanPanelMatTrackerButton_FormatShortText(e.short)..": ";
		else
			title = e.item..": ";
		end
    val = TitanPanelMatTrackerButton_MatsTotalFromCode(d);
   	text = format("%d",val);
		if(TitanGetVar(TITAN_MATTRACKER_ID, "ShowColoredText")) then
			text = TitanPanelMatTrackerButton_FormatShortText(e.short,text);
		end;
		table.insert(liste,title);
		table.insert(liste,TitanUtils_GetHighlightText(text));
	end;

	if(table.getn(liste) == 0) then
		return TITAN_MATTRACKER_TEXT,"";
	end
	return unpack(liste);
end

function TitanPanelMatTrackerButton_GetTooltipText()
  if (not MTracker or not MTracker:getMaterialCounts()) then
    return "Materials Tracker not loaded";
  end
  
	local retstr,cat,val,noCat = "","","","","";
	local i,e;

  -- Header --
  retstr = "\nItem:\t";
  local showZero  = TitanGetVar(TITAN_MATTRACKER_ID, "tooltip_showZero");
  local useInv    = TitanGetVar(TITAN_MATTRACKER_ID, "tooltip_loc_inv");
  local useBank   = TitanGetVar(TITAN_MATTRACKER_ID, "tooltip_loc_bank");
  local useMail   = TitanGetVar(TITAN_MATTRACKER_ID, "tooltip_loc_mail");
  local useReroll = TitanGetVar(TITAN_MATTRACKER_ID, "tooltip_loc_reroll");
  local useGbank  = TitanGetVar(TITAN_MATTRACKER_ID, "tooltip_loc_gbank");
  local useTotal  = 0;
  local first = 1;
  if (useInv == 1) then
    if (first == 1) then
      first = 0;
    else
      retstr = retstr .. " | ";
    end
    retstr = retstr .. TITAN_MATTRACKER_LOC_INV_SHORT;
  end
  if (useMail == 1) then
    if (first == 1) then
      first = 0;
    else
      retstr = retstr .. " | ";
    end
    retstr = retstr .. TITAN_MATTRACKER_LOC_MAIL_SHORT;
  end
  if (useBank == 1) then
    if (first == 1) then
      first = 0;
    else
      retstr = retstr .. " | ";
    end
    retstr = retstr .. TITAN_MATTRACKER_LOC_BANK_SHORT;
  end
  if (useGbank == 1) then
    if (first == 1) then
      first = 0;
    else
      retstr = retstr .. " | ";
    end
    retstr = retstr .. TITAN_MATTRACKER_LOC_GBANK_SHORT;
  end
  if (useReroll == 1) then
    if (first == 1) then
      first = 0;
    else
      retstr = retstr .. " | ";
    end
    retstr = retstr .. TITAN_MATTRACKER_LOC_REROLL_SHORT;
  end
  if (not useInv and not useBank and not useMail and not useReroll and not useGbank) then
    retstr = retstr .. TITAN_MATTRACKER_LOC_TOTAL .. ":";
    useTotal = 1;
  end
  
  local bag,bank,mail,reroll, gbank;
  local m;
  
  -- Loop through the Materials
	for cat, m in pairs(TITAN_MATTRACKER_MATS.byCat) do -- Loop through the categories
    if(TitanPanelMatTrackerButton_TooltipCatDisp(cat)) then  -- If the Category the item belongs to is being shown
      if(retstr ~= "") then
        retstr = retstr .. "\n"                                                      --  goto next line in output
      end
      retstr = retstr .. "\n" .. TitanUtils_GetGreenText(getglobal('TITAN_MATTRACKER_CAT_'..cat)..":");  -- Output the Category Title
      for i, e in pairs(m) do -- Loop through the mats in the category
        if(TitanPanelMatTrackerButton_ItemTracked(e)) then  -- If the Item is tracked by Materials Tracker
          if (showZero == 1 or TitanPanelMatTrackerButton_MatsTotalFromCode(e) > 0) then  -- If we are to show zero or there is more then zero of item
            if (useTotal == 1) then                                                            -- If we are showing the total
              val = format("%d",TitanPanelMatTrackerButton_MatsTotalFromCode(e));         -- Grabbing total
              retstr = retstr.. "\n".. TITAN_MATTRACKER_MATS.byId[e].item..":\t".. TitanUtils_GetHighlightText(val);          -- Output the item name and total number
            else
              bag, bank, mail, reroll, gbank = MTracker:getMaterialCounts(e); -- Grab the item numbers
              bag = format("%7d",bag);                                                                           -- Format the Numbers
              bank = format("%7d",bank);
              mail = format("%7d",mail);
              reroll = format("%7d",reroll);
              gbank = format("%7d",gbank);
              retstr = retstr.. "\n".. TITAN_MATTRACKER_MATS.byId[e].item..":\t";                                                               -- Output the Item name starting on a new line
              first = 1;                                                                                            -- Set First to be true
              if (useInv == 1) then                                                                                 -- If we are outputting the inventory amount
                if (first == 1) then                                                                                -- if this is the first output
                  first = 0;                                                                                        -- Set first to be false/0
                else                                                                                                -- Not first so
                  retstr = retstr .. "  |  ";                                                                       -- Output the divider
                end
                retstr = retstr .. TitanUtils_GetHighlightText(bag);                                                -- Output the value in the inventory
              end
              -- Mail Output
              if (useMail == 1) then
                if (first == 1) then
                  first = 0;
                else
                  retstr = retstr .. "  |  ";
                end
                retstr = retstr .. TitanUtils_GetHighlightText(mail);
              end
              --  Output Bank Amounts
              if (useBank == 1) then
                if (first == 1) then
                  first = 0;
                else
                  retstr = retstr .. "  |  ";
                end
                retstr = retstr .. TitanUtils_GetHighlightText(bank);
              end
              --  Output Guild Bank Amounts
              if (useGbank == 1) then
                if (first == 1) then
                  first = 0;
                else
                  retstr = retstr .. "  |  ";
                end
                retstr = retstr .. TitanUtils_GetHighlightText(gbank);
              end
              -- Output other character amounts
              if (useReroll == 1) then
                if (first == 1) then
                  first = 0;
                else
                  retstr = retstr .. "  |  ";
                end
                retstr = retstr .. TitanUtils_GetHighlightText(reroll);
              end
            end     -- End Not using total
          end -- End Showing item
        end   -- End item is being tracked
      end     -- End Loop over the mats
    end       -- End Show category
  end       -- End Loop over the categories
	return retstr;  -- Output the formatted string
end  -- End TitanPanelMatTrackerButton_GetTooltipText

function TitanPanelMatTrackerButton_TooltipCatDisp(cat)
	local disp = TitanGetVar(TITAN_MATTRACKER_ID, "displayCats");
  local i,d,e;
  for i,d in pairs(disp) do
    e = TITAN_MATTRACKER_CATEGORIES[d];
    if (e == cat) then
      return true;
    end
  end
  return false;
end

function TitanPanelMatTrackerButton_MatsTotalFromCode(itemId)
  if (itemId == 0) then
    itemId = MTracker:getCodeFromName(name);
  end
  if (not itemId) then
    return 0;
  else
    if (MTracker) then
      local bag, bank, reroll, mail, gbank = MTracker:getMaterialCounts(itemId);
      local total = bag + bank + mail;
      return total;
    else
      return getItemCount(itemId,true) 
    end
  end
end

function TitanPanelMatTrackerButton_MatsTotalFromName(name)
  if (not name or name == '') then
    return 0;
  else
    return TitanPanelMatTrackerButton_MatsTotalFromCode(MTracker:getCodeFromName(name));
  end
end

function TitanPanelMatTrackerButton_FormatColoredText(colorCode, val)
  local color = "FFFFFF";
  
  if (TitanMatTracker_colors[colorCode]) then
    color = TitanMatTracker_colors[colorCode]
  end
  
  return '|cff'..color..val..FONT_COLOR_CODE_CLOSE
end
  
function TitanPanelMatTrackerButton_FormatShortText(short,val)
	local color = 'FFFFFF';
	local text = string.sub(short,2);
	local colorcode = string.sub(short,1,1);
	if(TitanMatTracker_colors[colorcode]) then
		color = TitanMatTracker_colors[colorcode];
	end;
	if(val) then
		return '|cff'.. color .. val .. FONT_COLOR_CODE_CLOSE
	else 
		return '|cff'.. color .. text .. FONT_COLOR_CODE_CLOSE
	end;
end


function TitanPanelMatTrackerButton_isdisp(val)
	local disp = TitanGetVar(TITAN_MATTRACKER_ID, "displayMats");
	local i,d;
	for i,d in pairs(disp) do
		if(d==val) then
			return 1;
		end
	end
	return nil;
end

function TitanPanelMatTrackerButton_isCatDisp(val)
	local disp = TitanGetVar(TITAN_MATTRACKER_ID, "displayCats");
	local i,d;
	for i,d in pairs(disp) do
		if(d==val) then
			return 1;
		end
	end
	return nil;
end

function TitanPanelMatTrackerButton_ItemTracked(itemId)
  --local code = MTracker:getCodeFromName(itemId);
  if (itemId and MTracker:ItemBeingTracked(itemId)) then
    return true;
  else
    return false;
  end
end

function TitanPanelMatTrackerButton_CatTracked(cat)
  local i, e;
  for i,e in pairs(TITAN_MATTRACKER_MATS.byCat[cat]) do
    if (TitanPanelMatTrackerButton_ItemTracked(e)) then
      return true;
    end
  end
  
  -- if it gets here its false;
  return false;
end

-- Right Click Option Menu
function TitanPanelRightClickMenu_PrepareMatTrackerMenu(self, level)
	local id = "MatTracker";
	local info = {};
	local i,cat,disp,val, mat;

  if (UIDROPDOWNMENU_MENU_LEVEL == 3) then
    if (UIDROPDOWNMENU_MENU_VALUE == "cat") then
      -- Show Categories
			for i,cat in pairs(TITAN_MATTRACKER_CATEGORIES) do
        if (TitanPanelMatTrackerButton_CatTracked(cat)) then
          info = {};
          info.text = getglobal('TITAN_MATTRACKER_CAT_'..cat);
          info.func = function() TitanPanelMatTrackerButton_SetCatDisplay(i) end
          info.checked = TitanPanelMatTrackerButton_isCatDisp(i);
          info.keepShownOnClick = 1;
          info.value = i;
          UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
        end
			end
    end
    
    if (UIDROPDOWNMENU_MENU_VALUE == "loc") then
      -- Show Locations
      TitanPanelMatTrackerButton_AddToggleVar(TITAN_MATTRACKER_LOC_INV,     TITAN_MATTRACKER_ID,'tooltip_loc_inv');
      TitanPanelMatTrackerButton_AddToggleVar(TITAN_MATTRACKER_LOC_MAIL,    TITAN_MATTRACKER_ID,'tooltip_loc_mail');
      TitanPanelMatTrackerButton_AddToggleVar(TITAN_MATTRACKER_LOC_BANK,    TITAN_MATTRACKER_ID,'tooltip_loc_bank');
      TitanPanelMatTrackerButton_AddToggleVar(TITAN_MATTRACKER_LOC_GBANK,   TITAN_MATTRACKER_ID,'tooltip_loc_gbank');
      TitanPanelMatTrackerButton_AddToggleVar(TITAN_MATTRACKER_LOC_REROLL,  TITAN_MATTRACKER_ID,'tooltip_loc_reroll');
    end
  end    
  
	if (UIDROPDOWNMENU_MENU_LEVEL == 2) then
    if (UIDROPDOWNMENU_MENU_VALUE == "tooltip") then
      -- tooltip conf here
      TitanPanelRightClickMenu_AddTitle(TITAN_MATTRACKER_TOOLTIPCONF_TITLE,UIDROPDOWNMENU_MENU_LEVEL);
      -- toggle for Showing if val is zero
			TitanPanelMatTrackerButton_AddToggleVar(TITAN_MATTRACKER_TOOLTIPCONF_SHOWZERO, TITAN_MATTRACKER_ID,'tooltip_showZero');
      -- menu for Show Categories
      info = {};
      info.text = TITAN_MATTRACKER_TOOLTIPCONF_SHOWCAT;
      info.value = "cat";
      info.hasArrow = 1;
      UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
      -- menu for Show Location
      info.value = "loc";
      info.text  = TITAN_MATTRACKER_TOOLTIPCONF_SHOWLOC;
      UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
    else
      for i,e in pairs(TITAN_MATTRACKER_MATS.byCat[UIDROPDOWNMENU_MENU_VALUE]) do
        if(TitanPanelMatTrackerButton_ItemTracked(e)) then
          mat = TITAN_MATTRACKER_MATS.byId[e]
          info = {};
          info.text = '[' .. TitanPanelMatTrackerButton_FormatColoredText(mat.color, mat.short) .. '] ' .. mat.item;
          val = TitanPanelMatTrackerButton_MatsTotalFromCode(e);
          info.text = info.text .. " (".. format("%d",val).. ")";
          info.value = e;
          info.func = function() TitanPanelMatTrackerButton_SetDisplay(e) end
          info.checked = TitanPanelMatTrackerButton_isdisp(e);
          info.keepShownOnClick = 1;
          UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
        end
      end
    end
  end
	
  if (UIDROPDOWNMENU_MENU_LEVEL == 1) then
		if(not MTracker) then
			TitanPanelRightClickMenu_AddToggleLabelText(TITAN_MATTRACKER_ID);
			TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, id, TITAN_PANEL_MENU_FUNC_HIDE);	
		else
			TitanPanelRightClickMenu_AddTitle(TitanPlugins[TITAN_MATTRACKER_ID].menuText);
			TitanPanelRightClickMenu_AddSpacer(UIDROPDOWNMENU_MENU_LEVEL);
	
			info = {};
			info.text = TITAN_MATTRACKER_DISPLAY_NONE;
			info.value = 0;
			info.func = function() TitanPanelMatTrackerButton_SetDisplay(0) end
			disp = TitanGetVar(TITAN_MATTRACKER_ID, "displayMats");
			info.checked = not TitanPanelMatTrackerButton_hasdisp();
			UIDropDownMenu_AddButton(info);
			
			for i,cat in pairs(TITAN_MATTRACKER_CATEGORIES) do
        if (TitanPanelMatTrackerButton_CatTracked(cat)) then
          info = {};
          info.text = getglobal('TITAN_MATTRACKER_CAT_'..cat);
          info.hasArrow = 1;
          info.value = cat;
          UIDropDownMenu_AddButton(info);
        end
			end
	
			TitanPanelRightClickMenu_AddSpacer(UIDROPDOWNMENU_MENU_LEVEL);
      -- Tooltip Config --
      info = {};
      info.text = TITAN_MATTRACKER_TOOLTIPCONF_TITLE;
      info.hasArrow = 1;
      info.value = "tooltip";
      UIDropDownMenu_AddButton(info);
      
			TitanPanelRightClickMenu_AddSpacer(UIDROPDOWNMENU_MENU_LEVEL);
	
      TitanPanelMatTrackerButton_AddToggleVar(TITAN_MATTRACKER_SHOWICONS, TITAN_MATTRACKER_ID, 'showMatIcons')
			TitanPanelMatTrackerButton_AddToggleVar(TITAN_MATTRACKER_SHORTDISPLAY, TITAN_MATTRACKER_ID,'shortdisplay');
			TitanPanelRightClickMenu_AddToggleColoredText(TITAN_MATTRACKER_ID);
			TitanPanelRightClickMenu_AddCommand("Hide", id, TITAN_PANEL_MENU_FUNC_HIDE);
		end
	end
end

function TitanPanelMatTrackerButton_AddToggleVar(text, id, var)
	local info = {};
	info.text = text;
	info.value = var;
	info.func = function() TitanPanelRightClickMenu_ToggleVar({id, var}); TitanPanelMatTracker_UpdateButton(); end
	info.checked = TitanGetVar(id, var);
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
end

function TitanPanelMatTrackerButton_SetCatDisplay(value)
	local db = TitanGetVar(TITAN_MATTRACKER_ID, "displayCats");
	local i,d,found;
	if(value == 0) then
		TitanSetVar(TITAN_MATTRACKER_ID, "displayCats", {});
	else
		found = 0;
		for i,d in pairs(db) do
			if(d == value)then
				found = i;
			end
		end
		if(found > 0) then
			table.remove(db,found)
		else
			table.insert(db,value);
		end
		TitanSetVar(TITAN_MATTRACKER_ID, "displayCats", db);
	end;
	 TitanPanelMatTracker_UpdateButton(); 
end

function TitanPanelMatTrackerButton_SetDisplay(value)
	local db = TitanGetVar(TITAN_MATTRACKER_ID, "displayMats");
	local i,d,found;
	if(value == 0) then
		TitanSetVar(TITAN_MATTRACKER_ID, "displayMats", {});
	else
		found = 0;
		for i,d in pairs(db) do
			if(d == value)then
				found = i;
			end
		end
		if(found > 0) then
			table.remove(db,found)
		else
			while(table.getn(db)>TITAN_MATTRACKER_MAX_DISPLAY) do
				table.remove(db);
			end;
			table.insert(db,value);
		end
		TitanSetVar(TITAN_MATTRACKER_ID, "displayMats", db);
	end;
	 TitanPanelMatTracker_UpdateButton(); 
end

function TitanPanelMatTrackerButton_hasdisp()
	local disp = TitanGetVar(TITAN_MATTRACKER_ID, "displayMats");
	if(not disp) then
		return nil;
	end
	return table.getn(disp) > 0;
end
