-- TitanRecount

local TITAN_RECOUNT_ID = "Recount";
local TITAN_RECOUNT_VERSION = "0.10";
local L = LibStub("AceLocale-3.0"):GetLocale("Titan", true)
--ToDo: must update Titan(global) L somehow with this. atm label dirty-checked in buttonTextFunction
L["TITAN_RECOUNT_BUTTON_LABEL"] = "Recount";
L["TITAN_RECOUNT_MENU_DISPLAY_ON_RIGHT_SIDE"] = "Display on far right side";

function TitanPanelRecountButton_OnLoad(self)
	self.registry = {
		id = TITAN_RECOUNT_ID,
--		builtIn = 1,
		version = TITAN_RECOUNT_VERSION,
		menuText = "Recount",
		buttonTextFunction = "TitanPanelRecountButton_GetButtonText",
--		buttonTextFunction = nil,
		category = "Combat",
		tooltipTitle = "Recount",
		tooltipTextFunction = "TitanPanelRecountButton_GetTooltipText",
		icon = "Interface\\AddOns\\TitanRecount\\TitanRecount",
		iconButtonWidth = 16,
		iconWidth = 16,
		savedVariables = {
			DisplayOnRightSide = 0,
			ShowIcon = 1,
			ShowLabelText = 0,
			ShowTooltipText = 1,
			ShowMenuOptions = 1,
			ShowAdvancedMenus = 1,
		}
	};
end

function TitanPanelRecountButton_GetButtonText()
	if ( TitanGetVar(TITAN_RECOUNT_ID, "ShowLabelText") ) then
	        return L["TITAN_RECOUNT_BUTTON_LABEL"]
	else
--		-- so you cant disable both (icon and label)
--		if ( TitanGetVar(TITAN_RECOUNT_ID, "ShowIconText") ) then
			return ""
--		else
--		        return L["TITAN_RECOUNT_BUTTON_LABEL"]
--		end
	end
end

function TitanPanelRecountButton_GetTooltipText()
	local c = "|cff00ff00"
	return c.."Hint: Left-click to toggle Recount."
end

function TitanPanelRecountButton_OnClick(self, button)
        if (button == "LeftButton") then
		if Recount.MainWindow:IsShown()
		    then Recount.MainWindow:Hide()
		    else Recount.MainWindow:Show();Recount:RefreshMainWindow()
		end
        end
end

function TitanPanelRightClickMenu_PrepareRecountMenu()
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[TITAN_RECOUNT_ID].menuText);

	TitanPanelRightClickMenu_AddSpacer();     
--	TitanPanelRightClickMenu_AddToggleVar(L["TITAN_RECOUNT_MENU_DISPLAY_ON_RIGHT_SIDE"], TITAN_RECOUNT_ID, DisplayOnRightSide);
--	TitanPanelRightClickMenu_AddCommand(L["TITAN_RECOUNT_MENU_DISPLAY_ON_RIGHT_SIDE"], TITAN_RECOUNT_ID, TitanPanelRecountButton_ToggleRightSideDisplay);
-- TitanPanel.lua:function TitanPanel_GetPluginSide(id)
-- TitanPanel_GetPluginSide(id) will return "Right" only if
-- .xml inherits="TitanPanelIconTemplate", but as it so
-- we cant set icon to LEFT. They do dirty-hack for Clock.
	info = {};
	info.text = L["TITAN_RECOUNT_MENU_DISPLAY_ON_RIGHT_SIDE"];
	info.func = TitanPanelRecountButton_ToggleRightSideDisplay;
	info.checked = TitanGetVar(TITAN_RECOUNT_ID, "DisplayOnRightSide");
	UIDropDownMenu_AddButton(info);
--	TitanPanelRightClickMenu_AddToggleIcon(TITAN_RECOUNT_ID);
	TitanPanelRightClickMenu_AddToggleLabelText(TITAN_RECOUNT_ID);
--	TitanPanelRightClickMenu_AddToggleColoredText(TITAN_RECOUNT_ID);

	TitanPanelRightClickMenu_AddSpacer();     
	TitanPanelRightClickMenu_AddCommand(L["TITAN_PANEL_MENU_HIDE"], TITAN_RECOUNT_ID, TITAN_PANEL_MENU_FUNC_HIDE);
end

function TitanPanelRecountButton_ToggleRightSideDisplay()
	TitanToggleVar(TITAN_RECOUNT_ID, "DisplayOnRightSide");
	TitanPanelRecountButton_ToggleRightSideDisplay2(TITAN_RECOUNT_ID)
	TITAN_PANEL_SELECTED = TitanUtils_GetWhichBar(TITAN_RECOUNT_ID);
	TitanPanel_RemoveButton(TITAN_RECOUNT_ID);
--	TitanPanel_AddButton(TITAN_RECOUNT_ID);
	local bar = (TitanGetVar(name, "ForceBar") or "Bar")
	TitanUtils_AddButtonOnBar(bar, TITAN_RECOUNT_ID)
end

function TitanPanelRecountButton_OnUpdate(self)
	TitanPanelButton_UpdateButton(TITAN_RECOUNT_ID)
	-- FFFFFFFF...........
	-- TitanPanelTemplate.lua:function TitanPanelButton_GetType(id) onload fix
	-- determining plugin "side" by TitanPanelXXXTemplate type is wrong
	if TitanGetVar(TITAN_RECOUNT_ID, "DisplayOnRightSide") then
--ZZXXCC=1;
		local button = TitanUtils_GetButton(TITAN_RECOUNT_ID);
		if button then
			local text = _G[button:GetName().."Text"];
			if (text) then
				TitanPanelRecountButton_ToggleRightSideDisplay2(TITAN_RECOUNT_ID);
			end
		end
	end
end

-- they must rewrite TitanPanel_GetPluginSide()
-- and add new func to do same in right way
function TitanPanelRecountButton_ToggleRightSideDisplay2(id)
	local button = TitanUtils_GetButton(id);
	local buttonText = _G[button:GetName().."Text"];
	if not TitanGetVar(id, "ShowIcon") then
		TitanToggleVar(id, "ShowIcon");	
	end
	TitanPanelButton_UpdateButton(id);
	if buttonText then
		-- hide (set to right)
		buttonText:SetText("")
		button:SetWidth(16);
		TitanPlugins[id].buttonTextFunction = nil;
		_G["TitanPanel"..id.."ButtonText"] = nil;
		local index;
		local found = nil;
		for index, _ in ipairs(TITAN_PANEL_NONMOVABLE_PLUGINS) do
			if id == TITAN_PANEL_NONMOVABLE_PLUGINS[index] then
				found = true;
			end
		end
		if not found then table.insert(TITAN_PANEL_NONMOVABLE_PLUGINS, id); end
		if button:IsVisible() then
			TitanPanel_RemoveButton(id);
--			TitanPanel_AddButton(id);
			local bar = (TitanGetVar(name, "ForceBar") or "Bar")
			TitanUtils_AddButtonOnBar(bar, id)
		end
--		TitanToggleVar(id, "DisplayOnRightSide");
	else
		-- show (set to left)
		TitanPlugins[id].buttonTextFunction = "TitanPanelRecountButton_GetButtonText";
		button:CreateFontString("TitanPanel"..id.."ButtonText", "OVERLAY", "GameFontNormalSmall")
		buttonText = _G[button:GetName().."Text"];
		buttonText:SetJustifyH("LEFT");
		-- set font for the fontstring
-- ERROR: TitanRecount\TitanRecount.lua:139: attempt to index global 'media' (a nil value)
-- TitanPanelGetVar("FontName") == "Friz Quadrata TT"
-- media:Fetch("font", "Friz Quadrata TT") == ERROR: attempt to index global 'media' (a nil value)
		-- wtf, media:Fetch isnt working
--		local currentfont = media:Fetch("font", TitanPanelGetVar("FontName"))
		local currentfont, _, _ = GameFontNormalSmall:GetFont();  -- lazy: sorry 2all, who had other font ^_^
		buttonText:SetFont(currentfont, TitanPanelGetVar("FontSize"));
		local index;
		local found = nil;
		for index, _ in ipairs(TITAN_PANEL_NONMOVABLE_PLUGINS) do
			if id == TITAN_PANEL_NONMOVABLE_PLUGINS[index] then
				found = index;
			end
		end
		if found then table.remove(TITAN_PANEL_NONMOVABLE_PLUGINS, found); end
		if button:IsVisible() then
			TitanPanel_RemoveButton(id);
--			TitanPanel_AddButton(id);
			local bar = (TitanGetVar(name, "ForceBar") or "Bar")
			TitanUtils_AddButtonOnBar(bar, id)
		end
--		TitanToggleVar(id, "DisplayOnRightSide");		
	end
end
