--[[
	TitanSpeed: A simple speedometer.
	Author: Trentin - > Quel -> tainted -> TotalPackage
--]]

local menutext = "Titan|cffffaa00Spe|r|cffff8800ed|r"
local buttonlabel = "Speed: "
local ID = "Speed"
local elap, speed, pitch, prevs, prevp = 0, 0, 0, -2, -2
local GetUnitSpeed, GetUnitPitch, IsFlying, IsSwimming = GetUnitSpeed, GetUnitPitch, IsFlying, IsSwimming

-- Main button frame and addon base
local f = CreateFrame("Button", "TitanPanelSpeedButton", CreateFrame("Frame", nil, UIParent), "TitanPanelComboTemplate")
f:SetFrameStrata("FULLSCREEN")
f:SetScript("OnEvent", function(this, event, ...) this[event](this, ...) end)
f:RegisterEvent("ADDON_LOADED")

---------------------------
function f:ADDON_LOADED(a1)
---------------------------
	if a1 ~= "TitanSpeed" then return end
	self:UnregisterEvent("ADDON_LOADED")
	self.ADDON_LOADED = nil
	
	self.registry = {
		id = ID,
		menuText = menutext,
		buttonTextFunction = "TitanPanelSpeedButton_GetButtonText",
		tooltipTitle = ID,
		tooltipTextFunction = "TitanPanelSpeedButton_GetTooltipText",
		frequency = 0.5,
		icon = "Interface\\Icons\\Ability_Rogue_Sprint.blp",
		iconWidth = 16,
		category = "Information",
		savedVariables = {
			ShowIcon = 1,
			ShowLabelText = false,
			ShowTenth = false,
			ShowPitch = 1,
		},
	}
	self:SetScript("OnUpdate", function(this, a1)
		elap = elap + a1
		if elap < 1 then return end
		speed = GetUnitSpeed("player")
		pitch = ( (IsFlying() or IsSwimming()) and TitanGetVar(ID, "ShowPitch") and format(" %d\194\186|r", floor((GetUnitPitch("player") * 180 / PI) + 0.5)) )  or ""
		if speed == prevs and pitch == prevp then return end
		prevs, prevp = speed, pitch
		TitanPanelButton_UpdateButton(ID)
		elap = 0
	end)
		
	TitanPanelButton_OnLoad(self)
end

----------------------------------------------
function TitanPanelSpeedButton_GetButtonText()
----------------------------------------------
	local speedtext, pitchtext
	if not speed then
		speedtext = "|cffffffff??%%|r"
	else
		speedtext = speed / 7 * 100
		if TitanGetVar(ID, "ShowTenth") == 1 then
			speedtext = format("|cffffffff%.1f%%%s|r", speedtext, pitch)
		else
			speedtext = format("|cffffffff%d%%%s|r", floor(speedtext + 0.5), pitch)
		end
	end
	return buttonlabel, speedtext
end

-----------------------------------------------
function TitanPanelSpeedButton_GetTooltipText()
-----------------------------------------------
	return "Displays your moving speed as a \npercent (relative to your normal \nrunning speed) and pitch in degrees.\n|cff00ff00Use: Right-click for options.|r"
end


local function ToggleShowTenth()
	prevs = -2
	TitanToggleVar(ID, "ShowTenth")
end
local function ToggleShowPitch()
	prevp = -2
	TitanToggleVar(ID, "ShowPitch")
end
local temp = {}
local function UIDDM_Add(text, func, checked, keepShown)
	temp.text, temp.func, temp.checked, temp.keepShownOnClick = text, func, checked, keepShown
	UIDropDownMenu_AddButton(temp)
end
----------------------------------------------------
function TitanPanelRightClickMenu_PrepareSpeedMenu()
----------------------------------------------------
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[ID].menuText)
	
	UIDDM_Add("Show tenths", ToggleShowTenth, TitanGetVar(ID, "ShowTenth"), 1)
	UIDDM_Add("Show pitch", ToggleShowPitch, TitanGetVar(ID, "ShowPitch"), 1)
	TitanPanelRightClickMenu_AddToggleIcon(ID)
	TitanPanelRightClickMenu_AddToggleLabelText(ID)
	TitanPanelRightClickMenu_AddSpacer()
	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, ID, TITAN_PANEL_MENU_FUNC_HIDE)
end